Subject: bug#55283: ‘tests/guix-shell-export-manifest.sh’ fails on aarch64-linux

From: Efraim Flashner <[email-masked]>
Date: Mon, 9 May 2022 11:57:01 +0300

On Mon, May 09, 2022 at 11:44:28AM +0300, Efraim Flashner wrote:
> On Mon, May 09, 2022 at 12:14:50AM +0200, Ludovic Courtès wrote:
> > Hi!
> > 
> > Vagrant Cascadian <[email-masked]> skribis:
> > 
> > > Well, I guess I answered my initial question by reading the error
> > > message... guix/cpu.scm ... how did that work before for things like
> > > cross-building, where /proc/cpuinfo is *definitely* wrong to get
> > > information about the architecture you're building for?
> > 
> > (guix cpu) is used when passing ‘--tune’, which is used for native
> > builds:
> > 
> >   https://hpc.guix.info/blog/2022/01/tuning-packages-for-a-cpu-micro-architecture/
> 
> I have a WIP patch for adding CPU detection for aarch64. Perhaps it'll
> help with the issues?

(ins)[efraim@pbp guix]$ ./pre-inst-env guix shell --export-manifest gsl openblas gcc-toolchain --tune
;;; note: source file /home/efraim/workspace/guix/guix/cpu.scm
;;;       newer than compiled /home/efraim/workspace/guix/guix/cpu.go

;;; ("aarch64" #f #f #f #<<set> vhash: #<vhash 1602dca0 9 pairs> insert: #<procedure %insert (t-5ce36f5c768e728-317 t-5ce36f5c768e728-319)> ref: #<procedure vhash-assoc (key vhash #:optional equal? hash)>>)
hint: Consider passing the `--check' option once to make sure your shell does not clobber environment variables.

guix shell: tuning [email-masked] for CPU armv8-a
;; What follows is a "manifest" equivalent to the command line you gave.
;; You can store it in a file that you may then pass to any 'guix' command
;; that accepts a '--manifest' (or '-m') option.

(use-modules (guix transformations))

(define transform1
  (options->transformation '((tune . "armv8-a"))))

(packages->manifest
  (list (transform1 (specification->package "gsl"))
        (transform1 (specification->package "openblas"))
        (transform1
          (specification->package "gcc-toolchain"))))

-- 
Efraim Flashner   <[email-masked]>   אפרים פלשנר
GPG key = A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted